# Fydo's LD9 entry

import pygame, sys, os, random, math
from pygame import *

from hud import *

random.seed()

black = (0,0,0)
grey  = (75,75,75)
grey2 = (125,125,125)
white = (255,255,255)
green = (100,255,100)

redpiece = pygame.Surface((128,128))
bluepiece = pygame.Surface((128,128))
startpiece = pygame.Surface((128,128))
endpiece = pygame.Surface((128,128))
noredpiece = pygame.Surface((128,128))
nobluepiece = pygame.Surface((128,128))
nostartpiece = pygame.Surface((128,128))
noendpiece = pygame.Surface((128,128))

class Place:
    def __init__(self, newpos, newtype):
        self.pos = newpos
        self.type = newtype
        
    def draw(self, screen):
        if self.type == 1:
            screen.blit(bluepiece, (self.pos[0] - 128, self.pos[1] - 128))
        elif self.type == 2:
            screen.blit(redpiece, (self.pos[0] - 128, self.pos[1] - 128))
        elif self.type == 3:
            screen.blit(startpiece, (self.pos[0] - 128, self.pos[1] - 128))
        elif self.type == 4:
            screen.blit(endpiece, (self.pos[0] - 128, self.pos[1] - 128))

class Player:
    def __init__(self, newid, newimg):
        self.id = newid
        self.img = newimg
        self.position = 0
        self.score = 0
    
    def draw(self, screen, placepos):
        screen.blit(self.img, (placepos[0] + 40 - (25 * self.id) - 128, placepos[1] + 30 - 128) )

class Game:
    def figureWinner(self, player1, player2, winner):    
        if player1.score == player2.score:
            return 5
        
        if winner == 1:
            if player1.score > player2.score:
                return 3
            else:
                return 5
                
        if winner == 2:
            if player2.score > player1.score:
                return 4
            else:
                return 5
        
            
    def screenlimits(self, mousepos):
        if mousepos[1] >= (355):
            mousepos = (mousepos[0], (355))
        if mousepos[1] <= 30:
            mousepos = (mousepos[0], (30))
        if mousepos[0] <= 40:
            mousepos = ((40), mousepos[1])
        if mousepos[0] >= 600:
            mousepos = ((600), mousepos[1])
            
        return mousepos

    def Start(self, screen):
        global redpiece
        global bluepiece
        global startpiece
        global endpiece
        global noredpiece
        global nobluepiece
        global nostartpiece
        global noendpiece
        

        
        #yay image files!
        redpiece = pygame.image.load(os.path.join('data', 'red.png')).convert_alpha()
        bluepiece = pygame.image.load(os.path.join('data', 'blue.png')).convert_alpha()
        startpiece = pygame.image.load(os.path.join('data', 'start.png')).convert_alpha()
        endpiece = pygame.image.load(os.path.join('data', 'end.png')).convert_alpha()
        noredpiece = pygame.image.load(os.path.join('data', 'red-no.png')).convert_alpha()
        nobluepiece = pygame.image.load(os.path.join('data', 'blue-no.png')).convert_alpha()
        nostartpiece = pygame.image.load(os.path.join('data', 'start-no.png')).convert_alpha()
        noendpiece = pygame.image.load(os.path.join('data', 'end-no.png')).convert_alpha()
        imgcursor = pygame.image.load(os.path.join('data', 'cursor.png')).convert_alpha()
        imgplayer1 = pygame.image.load(os.path.join('data', 'player1.png')).convert_alpha()
        imgplayer2 = pygame.image.load(os.path.join('data', 'player2.png')).convert_alpha()
        bannerbuild = pygame.image.load(os.path.join('data', 'buildingstage.png')).convert_alpha()
        bannerstart = pygame.image.load(os.path.join('data', 'gamestart.png')).convert_alpha()
        bannerp1win = pygame.image.load(os.path.join('data', 'p1win.png')).convert_alpha()
        bannerp2win = pygame.image.load(os.path.join('data', 'p2win.png')).convert_alpha()
        bannertie = pygame.image.load(os.path.join('data', 'tiegame.png')).convert_alpha()
        
        sndstep = pygame.mixer.Sound(os.path.join('data', 'step.ogg'))
        sndplace = pygame.mixer.Sound(os.path.join('data', 'place.ogg'))
        snderr = pygame.mixer.Sound(os.path.join('data', 'err.ogg'))
        sndroll = pygame.mixer.Sound(os.path.join('data', 'roll.ogg'))
        
        myhud = Hud()
        
        player1 = Player(1, imgplayer1)
        player2 = Player(2, imgplayer2)
        
        mousepos = (0,0)
        realmousepos = (0,0)
        linewidth = 8
        cursorsize = 60
        currtype = 3
        placementMode = True
        placementValid = True
        rollinprogress = False
        rolltimer = 0
        playerTurn = 1
        places = []
        bannerpos = (205, -160)
        bannervelocity = 0.0
        bannertimer = 0
        bannerflag = 1
        
        while 1:
            time.Clock().tick(60)
            
            for event in pygame.event.get():
                if event.type == pygame.QUIT: 
                    sys.exit()
                elif event.type == KEYDOWN:
                    if (event.key == K_ESCAPE):
                        sys.exit()
                elif event.type == MOUSEMOTION:
                    mousepos = event.pos
                    realmousepos = mousepos
                    mousepos = self.screenlimits(mousepos)
                    
                elif event.type == MOUSEBUTTONDOWN:
                    mousepos = event.pos
                    realmousepos = mousepos
                    mousepos = self.screenlimits(mousepos)
                        
                    if event.button == 1 and (event.pos[1] > 410):
                        
                        if placementMode:
                            currtype = myhud.checkClick(realmousepos, currtype)
                        else:
                            sndroll.play()
                            roll = myhud.checkClick(realmousepos, 5)
                            myhud.message = "Player " + str(playerTurn) + " just rolled a " + str(roll) + "!"
                            rollinprogress = True
                        
                        
                    elif event.button == 1 and placementMode and placementValid and myhud.usePiece(currtype):
                        
                        newplace = Place(mousepos, currtype)
                        places.append(newplace)
                        sndplace.play()
                        playerTurn += 1
                        if playerTurn > 2:
                            playerTurn = 1
                            
                        myhud.message = "Building Stage: Player " + str(playerTurn) + ", it's your turn!"
                        
                        if currtype == 3:
                            currtype = 1
                            myhud.enableButtons()
                            
                        if currtype == 4: # placed END piece, should switch to gameplay mode
                            placementMode = False
                            playerTurn = 1
                            myhud.startGame()
                            myhud.updateScores(player1.score, player2.score)
                            bannerflag = 2
                    elif event.button == 1 and placementValid == False:
                        snderr.play()
                        
                    if event.button == 3 and placementMode and currtype != 3:
                        currtype += 1
                        if currtype == 3:
                            currtype = 4
                        if currtype > 4:
                            currtype = 1
            
            screen.fill(white)
            
            count = 0
            oldplace = (0,0)
            for place in places:
                count += 1
                if (count >= 2):
                    draw.line(screen, grey, oldplace.pos, place.pos, 8)
                    draw.line(screen, grey2, oldplace.pos, place.pos, 3)
                oldplace = place
                
            if (count > 0) and placementMode:
                draw.line(screen, black, oldplace.pos, mousepos, 8)
                
            for place in places:
                place.draw(screen)
            
            if placementMode == True:

                placementValid = True #innocent until proven guilty
                
                for place in places:
                    if (place.pos[0] < (mousepos[0] + 90)) and (place.pos[0] > (mousepos[0] - 90)):
                        if (place.pos[1] < (mousepos[1] + 60)) and (place.pos[1] > (mousepos[1] - 60)):
                            placementValid = False
                    
                coords = (mousepos[0] - 128, mousepos[1] - 128)
                if currtype == 1:
                    if placementValid == True:
                        screen.blit(bluepiece, coords)
                    else:
                        screen.blit(nobluepiece, coords)
                elif currtype == 2:
                    if placementValid == True:
                        screen.blit(redpiece, coords)
                    else:
                        screen.blit(noredpiece, coords)
                elif currtype == 3:
                    if placementValid == True:
                        screen.blit(startpiece, coords)
                    else:
                        screen.blit(nostartpiece, coords)
                elif currtype == 4:
                    if placementValid == True:
                        screen.blit(endpiece, coords)
                    else:
                        screen.blit(noendpiece, coords)
            else:
                
                if rollinprogress:
                    rolltimer += 0.0166
                    if rolltimer >= 0.6:
                        rolltimer = 0
                        roll -= 1
                        sndstep.play()
                        if playerTurn == 1:
                            player1.position += 1
                            if player1.position >= count:
                                player1.position = count - 1
                                roll = 0
                        elif playerTurn == 2:
                            player2.position += 1
                            if player2.position >= count:
                                player2.position = count - 1
                                roll = 0
                        
                        if roll == 0:
                            rollinprogress = False
                            #apply effects
                            if playerTurn == 1:
                                if places[player1.position].type == 1:
                                    player1.score += 2
                                    myhud.message = "Player 1 landed on a blue space! 2 points! YAY! -- Player 2's turn"
                                    myhud.updateScores(player1.score, player2.score)
                                elif places[player1.position].type == 2:
                                    player1.score -= 1
                                    myhud.message = "Player 1 landed on a red space! Loses a point! Oh noes! :( -- Player 2's turn"
                                    myhud.updateScores(player1.score, player2.score)
                                elif places[player1.position].type == 4:
                                    #player1.score -= 1
                                    myhud.message = "Player 1 has reached the end!"
                                    bannerflag = self.figureWinner(player1, player2, 1)
                                    
                                playerTurn = 2
                            elif playerTurn == 2:
                                if places[player2.position].type == 1:
                                    player2.score += 2
                                    myhud.message = "Player 2 landed on a blue space! 2 points! YAY! -- Player 1's turn"
                                    myhud.updateScores(player1.score, player2.score)
                                elif places[player2.position].type == 2:
                                    player2.score -= 1
                                    myhud.message = "Player 2 landed on a red space! Loses a point! Oh noes! :( -- Player 1's turn"
                                    myhud.updateScores(player1.score, player2.score)
                                elif places[player2.position].type == 4:
                                    #player1.score -= 1
                                    myhud.message = "Player 2 has reached the end!"
                                    bannerflag = self.figureWinner(player1, player2, 2)
                                
                                playerTurn = 1
                
                player1.draw(screen, places[player1.position].pos)
                #print places[player1.position].pos
                player2.draw(screen, places[player2.position].pos)
                #print places[player2.position].pos
                
                  
            myhud.draw(screen, playerTurn)
            
            if realmousepos[1] > 410 and placementMode:
                screen.blit(imgcursor, realmousepos)
            elif placementMode == False:
                screen.blit(imgcursor, realmousepos)
            
            if bannerflag != 0:
                if bannerpos[1] < 181:
                    bannervelocity += (9.81) * 0.0166
                    bannerpos = (bannerpos[0], int(bannerpos[1] + bannervelocity))
                else:
                    bannertimer += 0.0166
                    if bannertimer > 2:
                        if bannerflag == 3 or bannerflag == 4 or bannerflag == 5:
                            return
                        bannerflag = 0
                        bannerpos = (205, -160)
                        bannervelocity = 0.0
                        bannertimer = 0
           
                if bannerflag == 1:
                    screen.blit(bannerbuild, bannerpos)
                if bannerflag == 2:
                    screen.blit(bannerstart, bannerpos)
                if bannerflag == 3:
                    screen.blit(bannerp1win, bannerpos)
                if bannerflag == 4:
                    screen.blit(bannerp2win, bannerpos)
                if bannerflag == 5:
                    screen.blit(bannertie, bannerpos)
            
            display.flip()

if __name__ == '__main__':

        #pygame.mixer.pre_init(22050, -16, 1, 2048)
    pygame.init()

    size = width, height = 640, 480
    
    screen = display.set_mode(size)#, HWSURFACE|DOUBLEBUF)

    Start(screen)