#hud class for fydo's game for LD9

import pygame, sys, os, random, math
from pygame import *

class Button:
    def __init__(self, newtype, newpos, newquan, newimg, newfont):
        self.type = newtype #1 = blue, 2 = red, 4 = end
        self.pos = newpos
        self.quantity = newquan
        self.img = newimg
        self.font = newfont
        self.buttonsEnabled = False
        
    def draw(self, screen):
        screen.blit(self.img, self.pos)
        if self.type != 5:
            text = self.font.render("(" + str(self.quantity) + ")", 1, (0,0,0))
            screen.blit(text, (self.pos[0] + 58, self.pos[1] + 9))
        else:
            text = self.font.render("  " + str(self.quantity), 1, (0,0,0))
            screen.blit(text, (self.pos[0] + 56, self.pos[1] + 9))
        

class Hud:
    def __init__(self):
        self.bg = pygame.image.load(os.path.join('data', 'hud.png')).convert_alpha()
        self.butblue = pygame.image.load(os.path.join('data', 'but-blue.png')).convert_alpha()
        self.butred = pygame.image.load(os.path.join('data', 'but-red.png')).convert_alpha()
        self.butend = pygame.image.load(os.path.join('data', 'but-end.png')).convert_alpha()
        self.butroll = pygame.image.load(os.path.join('data', 'but-roll.png')).convert_alpha()
        self.playericons = pygame.image.load(os.path.join('data', 'player-icons.png')).convert_alpha()
        self.select = pygame.image.load(os.path.join('data', 'select.png')).convert_alpha()
        self.font = pygame.font.Font(os.path.join('data', 'Vera.ttf'), 13)
        self.player1text = self.font.render('player 1', 1, (0,0,0))
        self.player2text = self.font.render('player 2', 1, (0,0,0))
        self.message = "Building Stage: Player 1, please place the starting location space!"
        self.buttons = []
    
    def checkClick(self, pos, type):
        for but in self.buttons:
            if but.pos[0] < pos[0] and but.pos[0] + 93 > pos[0]:
                if but.pos[1] < pos[1] and but.pos[1] + 34 > pos[1]:
                    type = but.type
                    if type == 5:
                        but.quantity = random.randint(1,3)
                        type = but.quantity
        
        return type
        
    def updateScores(self, p1score, p2score):
        self.player1text = self.font.render('player 1 (' + str(p1score) + ' points)', 1, (0,0,0))
        self.player2text = self.font.render('player 2 (' + str(p2score) + ' points)', 1, (0,0,0))
                    
    def usePiece(self, type):
    
        if type == 3:
            return True
    
        if type == 1:
            self.buttons[0].quantity -= 1
            if self.buttons[0].quantity > -1:
                return True
            else:
                self.buttons[0].quantity = 0
                return False
        elif type == 2:
            self.buttons[1].quantity -= 1
            if self.buttons[1].quantity > -1:
                return True
            else:
                self.buttons[1].quantity = 0
                return False
        elif type == 4:
            if self.buttons[0].quantity < 4 and self.buttons[1].quantity < 3:
                self.buttons[2].quantity -= 1
                if self.buttons[2].quantity > -1:
                    return True
                else:
                    self.buttons[2].quantity = 0
                    return False
            else:
                self.message = 'You must use at least half of each kind of space on the board!'
                return False
        
    def startGame(self):
        self.buttons = []
        temp = Button(5, (531, 420), 1, self.butroll, self.font)
        self.buttons.append(temp)
        self.message = "End space placed! Game starting! Player 1, roll the 3-sided die!"
    
    def enableButtons(self):
        self.buttonsEnabled = True
        temp = Button(1, (531 - ((93+15)*2), 420), 7, self.butblue, self.font)
        self.buttons.append(temp)
        temp = Button(2, (531 - (93+15), 420), 4, self.butred, self.font)
        self.buttons.append(temp)
        temp = Button(4, (531, 420), 1, self.butend, self.font)
        self.buttons.append(temp)
    
    def draw(self, screen, turn):
        screen.blit(self.bg, (0, 410))
        
        for buts in self.buttons:
            buts.draw(screen)        
        
        if self.message != "":
            text = self.font.render(self.message, 1, (255,255,255))
            screen.blit(text, (14, 461))
        
        screen.blit(self.playericons, (28, 427), (64, 0, 32, 32))        
        screen.blit(self.playericons, (15, 412), (0, 0, 32, 32))

        screen.blit(self.player1text, (50, 420))
        screen.blit(self.player2text, (57, 439))
        
        if turn == 1:
            screen.blit(self.select, (4, 424))
        else:
            screen.blit(self.select, (9, 439))