# menu for the game

import os, sys
import pygame
from pygame.locals import *

class Menu:
	def __init__(self):
		#load stuff
		self.bgimage = pygame.image.load(os.path.join('data', 'menu.png')).convert()
		self.selectimage = pygame.image.load(os.path.join('data', 'select.png')).convert_alpha()
		self.movesound = pygame.mixer.Sound(os.path.join('data', 'menu.ogg'))
		self.selsound = pygame.mixer.Sound(os.path.join('data', 'menuselect.ogg'))
		self.selection = 0
			
	def PickIt(self, screen):
		#FANCY FADE OUT!
		for x in range(50):
			temp = x
			x = 50 - x
			screen.fill((0,0,0))
			work = self.bgimage
			work.set_alpha((x * 255) / 50.0, RLEACCEL)
			screen.blit(work, (0,0))
			pygame.display.flip()
			pygame.time.wait(10)
		
		return self.selection
		
	def MoveDown(self, screen):
		if self.selection == 2:
			return
		self.movesound.play()
		temploc = 104 + (self.selection * 35)
		yvel = 0
		self.selection += 1
		while (temploc < (104 + (self.selection * 35))):
			yvel += 1
			screen.blit(self.bgimage, (0,0))
			temploc += yvel
			selectloc = (390,temploc)
			screen.blit(self.selectimage, selectloc)
			pygame.display.flip()
			pygame.time.wait(15)
		
			
	def MoveUp(self, screen):
		if self.selection == 0:
			return
		self.movesound.play()
		temploc = 104 + (self.selection * 35)
		yvel = 0
		self.selection -= 1
		while (temploc > (104 + (self.selection * 35))):
			yvel += 1
			screen.blit(self.bgimage, (0,0))
			temploc -= yvel
			selectloc = (390,temploc)
			screen.blit(self.selectimage, selectloc)
			pygame.display.flip()
			pygame.time.wait(15)
		
			
	def ShowMenu(self, screen):
		#screen.fill((0,0,0))
		pygame.mixer.stop
		for x in range(40):
			screen.fill((0,0,0))
			work = self.bgimage
			work.set_alpha((x * 255) / 40.0, RLEACCEL)
			screen.blit(work, (0,0))
			pygame.display.flip()
			pygame.time.wait(10)
		
		while 1:
			for event in pygame.event.get():
				if event.type == pygame.QUIT: 
					sys.exit()
				elif event.type == KEYDOWN:
					if ((event.key == K_RIGHT) or (event.key == K_DOWN)):
						self.MoveDown(screen)
					elif ((event.key == K_LEFT) or (event.key == K_UP)):
						self.MoveUp(screen)
					elif ((event.key == K_SPACE) or (event.key == K_RETURN)):
						self.selsound.play()
						return self.PickIt(screen)
					elif (event.key == K_ESCAPE):
						self.selection = 2
						return self.PickIt(screen)
			
			screen.blit(self.bgimage, (0,0))
			selectloc = (390,104 + (self.selection * 35))
						
			screen.blit(self.selectimage, selectloc)
			pygame.display.flip()
			pygame.time.wait(25) #
					
		